<?php

namespace App\Console\Commands;

use App\Services\UserService;
use Illuminate\Console\Command;

class DeleteUnverifiedUsersCommand extends Command
{
    protected $signature = 'delete:unverified-users';

    protected $description = 'Deletes the unverified users after 24h';

    public function handle(UserService $userService): void
    {
        $timeAgo = now()->subHours();

        $users = $userService->getUnverifiedUsers($timeAgo);

        if ($users->isNotEmpty()) {
            $userService->massDelete($users);
        }
    }
}
