<?php

namespace App\Http\Controllers\BackOffice;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;

class AuthController extends Controller
{
    public function index()
    {
        if (auth()->check() && auth()->user()->is_admin) {
            return redirect()->route('backoffice.games.index');
        }

        return view('backoffice.auth.login');
    }

    public function store(Request $request)
    {
        if (auth()->check() && auth()->user()->is_admin) {
            return redirect()->route('backoffice.games.index');
        }

        $credentials = $request->only('email', 'password');

        $userExists = User::where('email', $credentials['email'])
            ->where('is_admin', true)
            ->first();


        if (is_null($userExists)) {
            return back()->withErrors([
                'email' => 'Credenciais inválidas'
            ]);
        }

        if (auth()->attempt($credentials)) {
            return redirect()->route('backoffice.games.index');
        }

        return back()->withErrors([
            'email' => 'Credenciais inválidas'
        ]);
    }

    public function logout()
    {
        auth()->logout();

        return redirect()->route('backoffice.login');
    }
}
