<?php

namespace App\Http\Controllers\BackOffice;

use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Artisan;

class CommandController extends Controller
{
    public function show(string $command)
    {
        abort_if(!config('app.debug') && auth()->id() !== 1, 404);
        
        try {
            Artisan::call($command);
            return response()->json(['command' => $command, 'output' => Artisan::output()]);
        } catch (\Throwable $th) {
            return response()->json(['command' => $command, 'output' => $th->getMessage()]);
        }
    }
}
