<?php

namespace App\Http\Controllers;

use App\Mappings\GameMapping;
use App\Services\GameService;

class GameController extends Controller
{

    public function __construct(
        protected GameService $gameService,
        protected GameMapping $gameMapping
    )
    {
    }

    public function index()
    {
        $user = auth()->user();
        $game = $this->gameService->findBySubdomain(getSubdomain());

        $currentTrial = $this->gameMapping::getCurrentTrial($user, $game);

        return view(
            'pages.game.show',
            compact('user', 'currentTrial')
        );
    }
}
