<?php

namespace App\Http\Controllers;

use App\Services\UserService;

class TwoFactorController extends Controller
{
    public function __construct(
        protected UserService $userService
    )
    {
    }

    public function index()
    {
        if (!auth()->check()) {
            return redirect()->route('auth.index');
        }

        if (session()->has('two_factor') && session('two_factor')) {
            return redirect()->route('games.index');
        }

        return view('pages.game.twofactor');
    }

    public function store()
    {
        session()->put('two_factor', true);
        session()->save();

        $this->userService->setVerifiedAt(auth()->user());

        return redirect()->route('games.index');
    }
}
