<?php

namespace App\Http\Requests;

use App\Models\User;
use Illuminate\Foundation\Http\FormRequest;

class TwoFactorAuthRequest extends FormRequest
{
    public function rules(): array
    {
        return [
            'twofactor' => [
                'required',
                'numeric',
                'digits:4',
                function ($attribute, $value, $fail) {
                    $user = User::where('id', $this->input('user_id'))
                        ->where('twofactor', $value)
                        ->exists();

                    if (!$user) {
                        $fail(__('auth.twofactor'));
                    }
                }],
        ];
    }

    public function authorize(): bool
    {
        return true;
    }
}
