<?php

namespace App\Mail;

use App\Models\User;
use App\Models\UserAction;
use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Mail\Mailables\Content;
use Illuminate\Mail\Mailables\Envelope;
use Illuminate\Queue\SerializesModels;

class GameWinMail extends Mailable
{
    use Queueable, SerializesModels;

    public UserAction $userAction;
    protected User $user;

    public function __construct(UserAction $userAction)
    {
        $this->userAction = $userAction;
        $this->user = $userAction->user;
    }

    public function envelope(): Envelope
    {
        return new Envelope(
            subject: 'Parabéns ' . $this->user->name . '!',
        );
    }

    public function content(): Content
    {
        return new Content(
            view: 'emails.game-win',
            with: ['user' => $this->user, 'userAction' => $this->userAction]
        );
    }

    public function attachments(): array
    {
        return [];
    }
}
