<?php

namespace App\Mappings;

use Illuminate\Support\Str;

class BetCodeMapping
{
    public static function generateBetCodeInfo($rawBetCode): array
    {
        $data = [
            'bet_code' => '',
            'name' => '',
            'city' => '',
            'nif_3' => '',
        ];


        $betCodeExploded = explode('+', $rawBetCode);
        foreach ($betCodeExploded as $key => $betCodeItem) {
            if ($key === 0) {
                $data['name'] = Str::title($betCodeItem);
            }
            if ($key === 1) {
                $data['city'] = Str::title($betCodeItem);
            }
            if ($key === 2) {
                $data['nif_3'] = $betCodeItem;
            }

            if ($key !== 0) {
                $data['bet_code'] .= '+';
            }
            $data['bet_code'] .= Str::ucfirst(Str::camel($betCodeItem));
        }

        $data['bet_code'] = str_replace(' ', '', $data['bet_code']);

        return $data;
    }
}
