<?php

namespace App\Mappings;

use App\Models\User;
use App\View\Components\LottoDrawPickStatusColoredComponent;
use App\View\Components\LottoDrawResultsColoredComponent;
use Illuminate\Support\Collection;

class GameActionModalMapping
{
    public static function getGameActionModalMessage($playsRemaining, Collection $userActions, $hasWon = false): array
    {
        $message = $hasWon
            ? [__('game-action-modal.bet_won')]
            : [$playsRemaining <= 0 ? __('game-action-modal.last_bet_lost') :  __('game-action-modal.bet_lost')];

        $message[] = (new LottoDrawPickStatusColoredComponent($userActions->last()))->render()->render();

        return $message;
    }

    /** @param Collection<UserAction> $userActions */
    public static function getResultsModalMessage(Collection $userActions, User $user): array
    {
        $message = [];

        $message[] = __('game-action-modal.game_finished');
        $message[] = (new LottoDrawResultsColoredComponent($userActions, $user))->render()->render();

        return $message;
    }
}
