<?php

namespace App\Mappings;

use App\Models\Game;
use App\Models\User;
use Illuminate\Support\Collection;

class GameMapping
{
    public static function getSelectedBallsValid(
        Collection $orangeBalls,
        Collection $greenBalls,
        Collection $purpleBalls
    ): bool
    {
        $totalBalls = $orangeBalls->count() + $greenBalls->count() + $purpleBalls->count();
        return (1 < $totalBalls && $totalBalls < 6) && !($purpleBalls->count() > 0 && $greenBalls->count() === 0);
    }

    public static function getCurrentTrial(?User $user, Game $game): int
    {
        $currentTrial = ($user?->confirmedUserActions?->count() ?? 0) + 1;
        if ($game->rounds <= $currentTrial) {
            return $game->rounds;
        }

        return $currentTrial;
    }
}
