<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;

class Game extends Model
{
    use SoftDeletes;

    protected $fillable = [
        'category_id',
        'subcategory_id',
        'subdomain',
        'rounds',
        'label',
        'description',
        'logo',
        'background',
        'sponsor_image',
        'sponsor',
        'about_us_image',
        'about_us',
        'prizes_image',
        'prizes',
        'status'
    ];

    protected $casts = [
        'rounds' => 'integer',
        'category_id' => 'integer',
        'subcategory_id' => 'integer',
        'status' => 'boolean'
    ];

    public function category(): BelongsTo
    {
        return $this->belongsTo(Category::class);
    }

    public function subcategory(): BelongsTo
    {
        return $this->belongsTo(Subcategory::class);
    }

    public function users(): HasMany
    {
        return $this->hasMany(User::class);
    }
}
