<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class UserAction extends Model
{
    protected $fillable = [
        'user_id',
        'orange_pick_number',
        'green_pick_number',
        'purple_pick_number',
        'orange_prize_draw',
        'green_prize_draw',
        'purple_prize_draw',
        'fix',
        'win',
        'confirmed',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'user_id' => 'integer',
        'orange_pick_number' => 'array',
        'green_pick_number' => 'array',
        'purple_pick_number' => 'array',
        'orange_prize_draw' => 'array',
        'green_prize_draw' => 'array',
        'purple_prize_draw' => 'array',
        'fix' => 'boolean',
        'win' => 'boolean',
        'confirmed' => 'boolean',
    ];

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }


}
