<?php

namespace App\Repositories;

use App\Models\User;
use App\Models\UserAction;
use Throwable;

class UserActionRepository
{
    public function store(User $user, $orangePickNumber, $greenPickNumber, $purplePickNumber, $orangePrizeDraw, $greenPrizeDraw, $purplePrizeDraw, $fix, $win, $confirmed): ?UserAction
    {
        try {
            $data = [
                'user_id' => $user->id,
                'orange_pick_number' => $orangePickNumber,
                'green_pick_number' => $greenPickNumber,
                'purple_pick_number' => $purplePickNumber,
                'orange_prize_draw' => $orangePrizeDraw,
                'green_prize_draw' => $greenPrizeDraw,
                'purple_prize_draw' => $purplePrizeDraw,
                'fix' => $fix,
                'win' => $win,
                'confirmed' => $confirmed,
            ];

            return UserAction::create($data);
        } catch (Throwable $e) {
            report($e);
            return null;
        }
    }

    public function confirm(UserAction $userAction): ?UserAction
    {
        try {
            $userAction->update([
                'confirmed' => true
            ]);
            return $userAction;
        } catch (Throwable $e) {
            report($e);
            return null;
        }
    }
}
