<?php

namespace App\Services;


use App\Models\Category;
use App\Models\Subcategory;
use App\Repositories\SubcategoryRepository;
use Illuminate\Support\Collection;

class SubcategoryService
{
    public function __construct(
        protected SubcategoryRepository $subcategoryRepository
    )
    {
    }

    public function all(): Collection
    {
        return $this->subcategoryRepository
            ->all();
    }

    public function find($id): ?Subcategory
    {
        return $this->subcategoryRepository
            ->find($id);
    }

    public function store(
        Category $category,
        string   $label
    ): ?Subcategory
    {
        return $this->subcategoryRepository
            ->store(
                $category,
                $label
            );
    }

    public function update(
        Subcategory $subcategory,
        string      $label
    ): bool
    {
        return $this->subcategoryRepository
            ->update(
                $subcategory,
                $label
            );
    }

    public function delete(Subcategory $subcategory): bool
    {
        return $this->subcategoryRepository
            ->delete(
                $subcategory
            );
    }
}
