<?php

namespace App\Services;

use App\Models\User;
use App\Models\UserAction;
use App\Repositories\UserActionRepository;

class UserActionService
{

    public function __construct(protected UserActionRepository $userActionRepository)
    {
    }

    public function store(User $user, $orangePickNumber, $greenPickNumber, $purplePickNumber, $orangePrizeDraw, $greenPrizeDraw, $purplePrizeDraw, $fix, $win, $confirmed): ?UserAction
    {
        return $this->userActionRepository->store(
            $user,
            $orangePickNumber,
            $greenPickNumber,
            $purplePickNumber,
            $orangePrizeDraw,
            $greenPrizeDraw,
            $purplePrizeDraw,
            $fix,
            $win,
            $confirmed
        );
    }

    public function confirm(UserAction $userAction): ?UserAction
    {
        return $this->userActionRepository->confirm(
            $userAction
        );
    }
}
