<?php

namespace App\View\Components;

use App\Models\User;
use App\Models\UserAction;
use Illuminate\Contracts\View\View;
use Illuminate\Support\Collection;
use Illuminate\View\Component;

class LottoDrawResultsColoredComponent extends Component
{
    /** @param Collection<UserAction> $userActions */
    public function __construct(public Collection $userActions, public User $user)
    {
    }

    public function render(): View
    {
        $userActions = $this->userActions;
        $user = $this->user;

        return view(
            'components.lotto-draw-results-colored-component',
            compact('userActions', 'user')
        );
    }
}
