<?php

namespace App\View\Components;

use App\Mappings\LottoNumberColorMapping;
use Closure;
use Illuminate\Contracts\View\View;
use Illuminate\View\Component;

class LottoNumbersColoredComponent extends Component
{
    public array $purples;
    public array $oranges;
    public array $greens;


    /**
     * Create a new component instance.
     */
    public function __construct(array $greens, array $purples, array $oranges)
    {
        $this->greens = $greens;
        $this->purples = $purples;
        $this->oranges = $oranges;
    }

    /**
     * Get the view / contents that represent the component.
     */
    public function render(): View|Closure|string
    {
        $greens = $this->greens;
        $purples = $this->purples;
        $oranges = $this->oranges;

        $greenColor = LottoNumberColorMapping::getColorByType('green');
        $purpleColor = LottoNumberColorMapping::getColorByType('purple');
        $orangeColor = LottoNumberColorMapping::getColorByType('orange');
        
        return view(
            'components.lotto-numbers-colored-component',
            compact('greens', 'purples', 'oranges', 'greenColor', 'purpleColor', 'orangeColor')
        );
    }
}
