<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('user_actions', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->unsignedBigInteger('user_id')->nullable();
            $table->string('green_pick_number');
            $table->string('green_prize_draw');
            $table->string('purple_pick_number');
            $table->string('purple_prize_draw');
            $table->string('orange_pick_number');
            $table->string('orange_prize_draw');
            $table->string('pick_number', 255)->default(0);
            $table->string('prize_draw', 255)->default(0);
            $table->boolean('fix')->default(false);
            $table->boolean('win')->default(false);
            $table->timestamps();
            $table->softDeletes();
            
            $table->foreign('user_id')
                ->references('id')->on('users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('user_actions');
    }
};
