<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::table('users', function (Blueprint $table) {
            $table->string('bet_code')->unique(false)->change();
            $table->string('email')->unique(false)->change();
            $table->unique(['game_id', 'bet_code'], 'users_game_id_bet_code_unique');
            $table->unique(['game_id', 'email'], 'users_game_id_email_unique');
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::table('users', function (Blueprint $table) {
            $table->string('bet_code')->unique()->change();
            $table->string('email')->unique()->change();
            $table->dropUnique('users_game_id_bet_code_unique');
            $table->dropUnique('users_game_id_email_unique');
        });
    }
};
