<?php

namespace Database\Seeders\Template;

use App\Models\User;
use Illuminate\Database\Seeder;
use Illuminate\Support\Facades\Hash;

class UserSeeder extends Seeder
{
    public function run(): void
    {
        $users = [
            [
                'id' => 1,
                'is_admin' => true,
                'game_id' => null,
                'twofactor' => '0000',
                'ip' => '127.0.0.1',
                'name' => 'Developer',
                'bet_code' => 'Developer',
                'email' => 'geral@riftweb.com',
                'nif_3' => '000000000',
                'city' => 'Lisboa',
                'email_verified_at' => now()->toDateTimeString(),
                'password' => Hash::make('C}i9q7DH5*y~c^]~GuVW,efNcj}z)boXYw9L')
            ],
            [
                'id' => 2,
                'is_admin' => true,
                'game_id' => null,
                'twofactor' => '0000',
                'ip' => '127.0.0.1',
                'name' => 'Admin',
                'bet_code' => 'Admin',
                'email' => 'noreply@clubesorte.org',
                'nif_3' => '000000000',
                'city' => 'Lisboa',
                'email_verified_at' => now()->toDateTimeString(),
                'password' => Hash::make('rzvrO@P9U,i1n@Xp!F3NxKC1W~Z[MHLj7^yC'),
            ]
        ];

        collect($users)->each(fn ($user) => User::updateOrCreate(['id' => $user['id']], $user));
    }
}
