<?php

/* Parameters for Notifications */
$notificationParams = [
    'regular' => [
        'prefix' => 'The',
        'prefixMultiple' => 'The',
        'name' => 'Game',
        'nameMultiple' => 'Games',
    ]
];

foreach ($notificationParams['regular'] as $key => $value) {
    $notificationParams['lowerCase'][$key] = strtolower($value);
}

foreach ($notificationParams['regular'] as $key => $value) {
    $notificationParams['upperCase'][$key] = ucfirst($value);
}

foreach ($notificationParams['regular'] as $key => $value) {
    $notificationParams['ucfirst'][$key] = ucfirst($value);
}
/* End parameters for Notifications */

return [
    'modal_message_on_status_false' => 'Inativo, aguarde a data para jogar nesta campanha.',
    'modal_message_on_status_false_btn' => 'Fechar',
    'status' => 'Estado',
    'status_input_label' => 'Ativo',
    'active' => 'Ativo',
    'inactive' => 'Inativo',
    'label' => '1. Título ou SloganCode',
    'subdomain' => '2. Subdominio (apenas o nome antes de @clubesorte.org)',
    'rounds' => '3. Número de Apostas Gratuitas',
    'category' => '4. Categoria',
    'subcategory' => '5. Subcategoria',
    'description' => '6. Descrição do Marquee',
    'logo_image' => '6.1. Logo do Patrocinador',
    'background_image' => '7. Background-Tema',
    'sponsor' => '9. Regulamento',
    'sponsor_image' => '9.1. Imagem do Regulamento',
    'about_us' => '8. Sobre a Campanha',
    'about_us_image' => '8.1. Imagem Sobre a Campanha',
    'prizes' => '10. Prémios',
    'prizes_image' => '10.1 Imagem dos Prémios',
    'notifications' => [
        'store' => [
            'success' => [
                'title' => $notificationParams['ucfirst']['name'],
                'description' => $notificationParams['ucfirst']['prefix'] . " " . $notificationParams['lowerCase']['name'] . " has been successfully added.",
            ],
            'error' => [
                'title' => 'Error',
                'description' => "Unable to add " . $notificationParams['lowerCase']['prefix'] . " " . $notificationParams['lowerCase']['name'] . '.',
            ],
        ],
        'patch' => [
            'success' => [
                'title' => $notificationParams['ucfirst']['name'] . ' Updated',
                'description' => "Data for this " . $notificationParams['lowerCase']['name'] . " has been successfully updated.",
            ],
            'error' => [
                'title' => 'Error',
                'description' => "Unable to update this " . $notificationParams['lowerCase']['name'] . ". Please try again later.",
            ],
            'warning' => [
                'title' => "Update " . $notificationParams['ucfirst']['name'],
                'description' => "Do you wish to change the data for this " . $notificationParams['ucfirst']['name'] . "? This action is irreversible.",
                'button' => 'Save'
            ]
        ],
        'delete' => [
            'success' => [
                'title' => $notificationParams['ucfirst']['name'] . " Deleted",
                'description' => "Data for this " . $notificationParams['lowerCase']['name'] . " has been permanently deleted.",
            ],
            'error' => [
                'title' => 'Error',
                'description' => "Unable to delete data for this " . $notificationParams['lowerCase']['name'] . ". Please try again later.",
            ],
            'warning' => [
                'title' => 'Delete ' . $notificationParams['ucfirst']['name'],
                'description' => "Do you wish to permanently delete the data for this " . $notificationParams['ucfirst']['name'] . "? This action is irreversible.",
                'button' => 'Delete'
            ]
        ]
    ]
];
