<?php

/* Parameters for Notifications */
$notificationParams = [
    'regular' => [
        'prefix' => 'A',
        'prefixMultiple' => 'As',
        'name' => 'Subcategoria',
        'nameMultiple' => 'Subcategorias',
    ]
];

foreach ($notificationParams['regular'] as $key => $value) {
    $notificationParams['lowerCase'][$key] = strtolower($value);
}

foreach ($notificationParams['regular'] as $key => $value) {
    $notificationParams['upperCase'][$key] = ucfirst($value);
}

foreach ($notificationParams['regular'] as $key => $value) {
    $notificationParams['ucfirst'][$key] = ucfirst($value);
}
/* End parameters for Notifications */

return [
    'notifications' => [
        'store' => [
            'success' => [
                'title' => $notificationParams['ucfirst']['name'],
                'description' => $notificationParams['ucfirst']['prefix'] . " " . $notificationParams['lowerCase']['name'] . " has been successfully added.",
            ],
            'error' => [
                'title' => 'Error',
                'description' => "Unable to add " . $notificationParams['lowerCase']['prefix'] . " " . $notificationParams['lowerCase']['name'] . '.',
            ],
        ],
        'patch' => [
            'success' => [
                'title' => $notificationParams['ucfirst']['name'] . ' Updated',
                'description' => "Data for this " . $notificationParams['lowerCase']['name'] . " has been successfully updated.",
            ],
            'error' => [
                'title' => 'Error',
                'description' => "Unable to update this " . $notificationParams['lowerCase']['name'] . ". Please try again later.",
            ],
            'warning' => [
                'title' => "Update " . $notificationParams['ucfirst']['name'],
                'description' => "Do you wish to change the data for this " . $notificationParams['ucfirst']['name'] . "? This action is irreversible.",
                'button' => 'Save'
            ]
        ],
        'delete' => [
            'success' => [
                'title' => $notificationParams['ucfirst']['name'] . " Deleted",
                'description' => "Data for this " . $notificationParams['lowerCase']['name'] . " has been permanently deleted.",
            ],
            'error' => [
                'title' => 'Error',
                'description' => "Unable to delete data for this " . $notificationParams['lowerCase']['name'] . ". Please try again later.",
            ],
            'warning' => [
                'title' => 'Delete ' . $notificationParams['ucfirst']['name'],
                'description' => "Do you wish to permanently delete the data for this " . $notificationParams['ucfirst']['name'] . "? This action is irreversible.",
                'button' => 'Delete'
            ]
        ]
    ]
];
