let board_size = 16;
let board_numbers = 2;
let board_stars = 1;
let board_stars_rosa = 1;
$(document).ready(function() {
    lotti();
});

function lotti() {
    for (let i = 1; i <= board_size; i++) {
        $('<span class="star" id="star' + i + '">' + i + '</span>').appendTo('#d4w4');
    }
    for (let i = 1; i <= board_numbers; i++) {
        $('<div class="slot orange" id="number' + i + '">?</div>').appendTo('#d4w3');
        $('<div class="slot orange" id="numbersort' + i + '">?</div>').appendTo('#d4w2');
    }
    for (let i = 1; i <= board_stars; i++) {
        $('<div class="slot green" id="star' + i + '">?</div>').appendTo('#d4w3');
        $('<div class="slot green" id="starsort' + i + '">?</div>').appendTo('#d4w2');
    }
    for (let i = 1; i <= board_stars_rosa; i++) {
        $('<div class="slot purple" id="starR' + i + '">?</div>').appendTo('#d4w3');
        $('<div class="slot purple" id="starRsort' + i + '">?</div>').appendTo('#d4w2');
    }


    let time = window.setInterval(function() {
        random(time, board_size);
    }, 200);

}

let random = function(time, board_length) {

    let board = [];
    do {
        board.push(board.length + 1);
    } while (board.length < board_length);

    let randomStars = board.slice().shuffle();
    $(board).each(function(i) {
        let star = $('#star' + this);
        star.html(randomStars[i]);
        blue(star);
    });

    let normal_numbers = randomStars.slice().shuffle();
    let selected_normal_numbers = normal_numbers.slice(0, board_numbers);
    $(selected_normal_numbers).each(function(i, value) {
        normal_numbers.splice($.inArray(value, normal_numbers), 1);
        $(board).each(function() {
            if ($('#star' + this).text() == value) {
                orange('#star' + value);
            }
        });
    });

    let green_numbers = normal_numbers.slice();
    let selected_stars_numbers = green_numbers.slice(0, board_stars);
    $(selected_stars_numbers).each(function(i, value) {
        normal_numbers.splice($.inArray(value, normal_numbers), 1);
        $(board).each(function() {
            if ($('#star' + this).text() == value) {
                green('#star' + value);
            }
        });
    });

    let purple_numbers = normal_numbers.slice();
    let selected_starsR_numbers = purple_numbers.slice(0, board_stars_rosa);
    $(selected_starsR_numbers).each(function(i, value) {
        purple('#star' + value);
        normal_numbers.splice($.inArray(value, normal_numbers), 1);
        $(board).each(function() {
            if ($('#star' + this).text() == value) {
                purple('#star' + value);
            }
        });
    });

};

Array.prototype.shuffle = function() {
    let i = this.length, j, temp;
    if (i == 0) return this;
    while (--i) {
        j = Math.floor(Math.random() * (i + 1));
        temp = this[i];
        this[i] = this[j];
        this[j] = temp;
    }
    return this;
};

let orange = function(el) {
    $(el).removeClass('blue').removeClass('green').removeClass('purple').addClass('orange');
};
let blue = function(el) {
    $(el).removeClass('orange').removeClass('green').removeClass('purple').addClass('blue');
};
let green = function(el) {
    $(el).removeClass('orange').removeClass('blue').removeClass('purple').addClass('green');
};
let purple = function(el) {
    $(el).removeClass('orange').removeClass('blue').removeClass('green').addClass('purple');
};


let audio;
let playlist;
let tracks;
let current;

init();

function init() {
    current = 0;
    audio = $('audio');
    playlist = $('#playlist');
    tracks = playlist.find('li a');
    let len = tracks.length - 1;
    if (audio.length !== 0) {
        audio[0].volume = .2;
        playlist.find('a').click(function(e) {
            e.preventDefault();
            let link = $(this);
            current = link.parent().index();
            run(link, audio[0]);
        });
        audio[0].addEventListener('ended', function() {
            current++;
            let link = '';
            if (current == len) {
                current = 0;
                link = playlist.find('a')[0];
            } else {
                link = playlist.find('a')[current];
            }
            run($(link), audio[0]);
        });
    }
}

function run(link, player) {
    player.src = link.attr('href');
    let par = link.parent();
    par.addClass('active').siblings().removeClass('active');
    audio[0].load();
    audio[0].play();
}

window.displayGameStatusFalseModal = function displayGameStatusFalseModal() {
    Swal.fire({
        position: 'top-start',
        icon: 'warning',
        html: window.language['games']['modal_message_on_status_false'],
        showCloseButton: true,
        showConfirmButton: true,
        confirmButtonText: window.language['games']['modal_message_on_status_false_btn'],
        showCancelButton: false,
        allowOutsideClick: false,
    });
};
