@extends('layouts.backoffice.backoffice')

@section('title')
    Nova Categoria
@endsection

@section('content')
    <div class="card">
        <div class="card-body">
            <form class="ajax"
                  method="POST"
                  enctype="multipart/form-data"
                  action="{{ route('backoffice.categories.store') }}"
                  data-action="store"
                  data-type="categories">
                @csrf
                <div class="form-group mt-2">
                    <label for="label">Nome da Categoria</label>
                    <input required type="text" class="form-control" id="label" name="label"
                           placeholder="Nome da Categoria">
                </div>
                <hr />
                <div class="row mt-2">
                    <div class="col-12 text-right">
                        <a class="btn btn-danger" href="{{ route('backoffice.categories.index') }}">
                            <i class="fa-solid fa-chevron-left"></i>
                            Cancelar
                        </a>
                        <button type="submit" class="btn btn-primary ml-2">
                            <i class="fa-solid fa-save"></i>
                            Guardar
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>
@endsection

@section('js')
    <script>
        $(() => {
            const tinymceSettings = {
                plugins: 'code table lists',
                toolbar: 'undo redo | blocks | bold italic | alignleft aligncenter alignright | indent outdent | bullist numlist | code | table',
            };
            tinymce.init({
                selector: 'textarea#description',
                ...tinymceSettings,
            });
            tinymce.init({
                selector: 'textarea#sponsor',
                ...tinymceSettings,
            });
            tinymce.init({
                selector: 'textarea#about_us',
                ...tinymceSettings,
            });
            tinymce.init({
                selector: 'textarea#prizes',
                ...tinymceSettings,
            });
        });
    </script>
@endsection('js')
