@extends('layouts.backoffice.backoffice')

@section('title')
    Categorias
@endsection

@section('content')
    <div class="container">
        <div class="row mb-2">
            <div class="col-12 text-right">
                <a class="btn btn-primary" href="{{ route('backoffice.categories.create') }}">
                    <i class="fa-solid fa-plus"></i>
                    Nova Categoria
                </a>
            </div>
        </div>
        <div class="card">
            <div class="card-body">
                <table class="table table-striped">
                    <thead>
                    <tr>
                        <th scope="col">Título</th>
                        <th scope="col">Data de Criação</th>
                        <th scope="col">Ações</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach ($categories as $category)
                        <tr>
                            <td>{{ $category->label }}</td>
                            <td>{{ $category->created_at->format('d-m-Y H:i') }}</td>
                            <td>
                                <a class="btn btn-primary"
                                   href="{{ route('backoffice.categories.edit', ['category' => $category->id]) }}">
                                    <i class="fa-solid fa-pencil"></i>
                                </a>
                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </div>
@endsection
