@extends('layouts.backoffice.backoffice')

@section('title')
    Campanhas
@endsection

@section('content')
    <div class="container">
        <div class="row mb-2">
            <div class="col-12 text-right">
                <a class="btn btn-primary" href="{{ route('backoffice.games.create') }}">
                    <i class="fa-solid fa-plus"></i>
                    Nova Campanha
                </a>
            </div>
        </div>
        <div class="card">
            <div class="card-body">
                <table class="table table-striped">
                    <thead>
                    <tr>
                        <th scope="col">Subdomínio</th>
                        <th scope="col">Título</th>
                        <th scope="col">Categoria</th>
                        <th scope="col">Subcategoria</th>
                        <th scope="col">Estado</th>
                        <th scope="col">Data de Criação</th>
                        <th scope="col">Ações</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach ($games as $game)
                        <tr>
                            <td>{{ $game->subdomain }}</td>
                            <td>{{ $game->label }}</td>
                            <td>
                                <a href="{{ route('backoffice.categories.edit', ['category' => $game->category_id]) }}">
                                    {{ $game->category->label }}
                                </a>
                            </td>
                            <td>
                                <a href="{{ route('backoffice.subcategories.edit', ['category' => $game->category_id, 'subcategory' => $game->subcategory_id]) }}">
                                    {{ $game->subcategory->label }}
                                </a>
                            </td>
                            <td>
                                @if ($game->status)
                                    <span class="badge bg-success text-white">
                                        {{ __('games.active') }}
                                    </span>
                                @else
                                    <span class="badge bg-danger text-white">
                                        {{ __('games.inactive') }}
                                    </span>
                                @endif
                            </td>
                            <td>{{ $game->created_at->format('d-m-Y H:i') }}</td>
                            <td>
                                <a class="btn btn-primary"
                                   href="{{ route('backoffice.games.edit', ['game' => $game->id]) }}">
                                    <i class="fa-solid fa-pencil"></i>
                                </a>
                            </td>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
    </div>


    <style>
        .table tr td {
            vertical-align: middle;
        }
    </style>
@endsection
