@extends('layouts.backoffice.backoffice')

@section('title')
    Editar Subcategoria
@endsection

@section('content')
    <div class="container">
        <div class="card">
            <div class="card-body">
                <form class="ajax"
                      method="POST"
                      enctype="multipart/form-data"
                      action="{{ route('backoffice.subcategories.update', ['category' => $category->id, 'subcategory' => $subcategory->id]) }}"
                      data-action="patch"
                      data-type="subcategories">
                    @csrf
                    @method('PUT')
                    <div class="form-group mt-2">
                        <label for="label">Nome da Subcategoria</label>
                        <input required type="text" class="form-control" id="label" name="label"
                               placeholder="Nome da Subcategoria"
                               value="{{ $subcategory->label }}">
                    </div>
                    <hr />
                    <div class="row mt-2">
                        <div class="col-12 text-right">
                            <a class="btn btn-danger"
                               href="{{ route('backoffice.categories.edit', ['category' => $category->id]) }}">
                                <i class="fa-solid fa-chevron-left"></i>
                                Cancelar
                            </a>
                            @if($subcategory->games->isNotEmpty())
                                <button type="button"
                                        class="btn btn-danger disabled ml-2"
                                        data-bs-toggle="tooltip"
                                        data-bs-title="Existem jogos associados a esta subcategoria"
                                        readonly>
                                    <i class="fa-solid fa-trash"></i>
                                    Eliminar
                                </button>
                            @else
                                <button type="button" onclick="$('#subcategory-delete-form').trigger('submit')"
                                        class="btn btn-danger ml-2">
                                    <i class="fa-solid fa-trash"></i>
                                    Eliminar
                                </button>
                            @endif
                            <button type="submit" class="btn btn-primary ml-2">
                                <i class="fa-solid fa-save"></i>
                                Guardar
                            </button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <form id="subcategory-delete-form"
          class="ajax"
          action="{{ route('backoffice.subcategories.destroy', ['category' => $category->id, 'subcategory' => $subcategory->id]) }}"
          method="POST"
          data-action="delete"
          data-type="subcategories">
        @csrf
        @method('DELETE')
    </form>
@endsection

@section('js')
    <style>
        .disabled {
            pointer-events: initial !important;
            cursor:         not-allowed !important;
        }
    </style>
@endsection
