<?php

use App\Http\Controllers\BackOffice\AuthController;
use App\Http\Controllers\BackOffice\CategoryController;
use App\Http\Controllers\BackOffice\CommandController;
use App\Http\Controllers\BackOffice\GameController;
use App\Http\Controllers\BackOffice\SubcategoryController;
use Illuminate\Support\Facades\Route;

/* Redirect Home to Backoffice Auth */
Route::get('', function () {
    return redirect()->route('backoffice.login');
});

Route::get('login', [AuthController::class, 'index'])->name('login');
Route::post('login', [AuthController::class, 'store'])->name('login.auth');
Route::get('logout', [AuthController::class, 'logout'])->name('logout');


Route::resource('games', GameController::class)->middleware('auth.backoffice')->except(['show']);
Route::get('categories/get-subcategories', [CategoryController::class, 'getSubcategories'])->middleware('auth.backoffice')->name('categories.get-subcategories');
Route::resource('categories', CategoryController::class)->middleware('auth.backoffice')->except(['show']);
Route::resource('categories/{category}/subcategories', SubcategoryController::class)->middleware('auth.backoffice')->except(['show', 'index']);

Route::resource('commands', CommandController::class)->middleware('auth.backoffice')->only(['show']);
