const mix = require('laravel-mix');

/*
 |--------------------------------------------------------------------------
 | Mix Asset Management
 |--------------------------------------------------------------------------
 |
 | Mix provides a clean, fluent API for defining some Webpack build steps
 | for your Laravel applications. By default, we are compiling the CSS
 | file for the application as well as bundling up all the JS files.
 |
 */
// Copy
mix.copy('resources/js/vendor/tinymce', 'public/js/tinymce');

// JS
mix.js('resources/js/app.js', 'public/assets/js')
    .js('resources/js/auth.js', 'public/assets/js')
    .js('resources/js/backoffice.js', 'public/assets/js');

// SCSS
mix.sass('resources/sass/app.scss', 'public/assets/css')
    .sass('resources/sass/backoffice.scss', 'public/assets/css');

if (mix.inProduction()) {
    mix.version();
}
